(define-module (ui x11 ajax)
    :use-module (alterator ajax)
    :use-module (alterator card-index)
    :export (init))

(define (ui-read)
  (f-reset "/x11"))

(define (ui-write)
  (f-submit "/x11"))

(define (update-depth-and-rr)
  (if (equal? (form-value "xresolution") "auto")
    (begin
      (form-update-value "xdepth" "auto")
      (form-update-activity "xdepth" #f)
	  (form-update-value "refresh_rate" #f)
	  (form-update-activity "refresh_rate" #f))
	(begin
	  (form-update-activity "xdepth" #t)
	  (form-update-activity "refresh_rate" #t))))

(define (init)
  (f-update-list "xdepth"      "/x11/avail_xdepth")
  (f-update-list "xresolution" "/x11/avail_xresolution")
  (ui-read)
  (update-depth-and-rr)
  (form-bind "submit"  "click" ui-write)
  (form-bind "reset"   "click" ui-read)
  (form-bind "xresolution" "change" update-depth-and-rr))

